// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "p4pApp.h"

#include "MainFrm.h"
#include "p4pAppDoc.h"
#include "p4pAppView.h"

#include "pack4png.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_1, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_R_SAVE, OnUpdateButtonRSave)
	ON_COMMAND(ID_BUTTON_R_SAVE, OnButtonRSave)
	ON_COMMAND(ID_BUTTON_PACK_1, OnButtonPack1)
	ON_COMMAND(ID_BUTTON_PACK_2, OnButtonPack2)
	ON_COMMAND(ID_BUTTON_PACK_3, OnButtonPack3)
	ON_COMMAND(ID_BUTTON_PACK_4, OnButtonPack4)
	ON_COMMAND(ID_BUTTON_BLEND, OnButtonBlend)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_BLEND, OnUpdateButtonBlend)
	ON_COMMAND(ID_BUTTON_QUANT, OnButtonQuant)
	ON_COMMAND(ID_BUTTON_WEB, OnButtonWeb)
	ON_COMMAND(ID_BUTTON_EQ, OnButtonEq)
	ON_COMMAND(ID_BUTTON_PACK_5, OnButtonPack5)
	ON_COMMAND(ID_BUTTON_PACK_6, OnButtonPack6)
	ON_COMMAND(ID_BUTTON_RESET, OnButtonReset)
	ON_COMMAND(ID_DOCUMENTATION, OnDocumentation)
	ON_COMMAND(ID_LOCATIONS, OnLocations)
	ON_COMMAND(ID_BUTTON_GCT, OnButtonGCT)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_2, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_3, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_4, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_QUANT, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_WEB, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_EQ, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_5, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PACK_6, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_RESET, OnUpdateButtonPack)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_GCT, OnUpdateButtonPack)
	ON_COMMAND(ID_BUTTON_ALL, OnButtonAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_ElimSparseZones = FALSE;
	m_highCompression = 6;
	m_HaveImage = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Make the blend button a check button
	int blendIndex = m_wndToolBar.CommandToIndex(ID_BUTTON_BLEND);
	m_wndToolBar.SetButtonStyle(blendIndex, TBBS_CHECKBOX);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);


	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnUpdateButtonBlend(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_ElimSparseZones == TRUE) m_wndToolBar.GetToolBarCtrl().SetState(ID_BUTTON_BLEND, TBSTATE_CHECKED);
}

void CMainFrame::OnButtonBlend() 
{
	// TODO: Add your command handler code here
	m_ElimSparseZones = 1 - m_ElimSparseZones;
}

void CMainFrame::OnUpdateButtonPack(CCmdUI* pCmdUI) 
{
	//pCmdUI->Enable(GET_APP->m_HaveImage);
	pCmdUI->Enable(m_HaveImage);
}

void CMainFrame::Call_pack4png(int qual) 
{
	if(qual<10) qual = m_ElimSparseZones*10+qual;
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.InvokeP4P(qual, 0);
}

void CMainFrame::OnButtonPack1() 
{
	Call_pack4png(1);
}

void CMainFrame::OnButtonPack2() 
{
	Call_pack4png(2);
}

void CMainFrame::OnButtonPack3() 
{
	Call_pack4png(3);
}

void CMainFrame::OnButtonPack4() 
{
	Call_pack4png(4);
}

void CMainFrame::OnButtonPack5() 
{
	Call_pack4png(5);
}

void CMainFrame::OnButtonPack6() 
{
	m_textDlg.m_compression = m_highCompression;	// default value is 6
	if(m_textDlg.DoModal()==IDOK) Call_pack4png(m_highCompression = m_textDlg.m_compression);
}

void CMainFrame::OnButtonGCT() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.InvokeP4P(1, 51);	// 51 is the "web-safe" color table step	
}

void CMainFrame::OnButtonQuant() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.Quantize(pDoc->m_Pix.MOST_SIGN_BITS);
}

void CMainFrame::OnButtonEq() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.Quantize(pDoc->m_Pix.HIST_EQUALIZATION);
}

void CMainFrame::OnUpdateButtonRSave(CCmdUI* pCmdUI) 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pCmdUI->Enable(pDoc->m_Pix.HaveOutput()==TRUE);
}

void CMainFrame::OnButtonRSave() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->SaveResult();	
}

void CMainFrame::OnButtonWeb() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.Web(pDoc->GetTitle());
}

void CMainFrame::OnButtonAll() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->All();
}

void CMainFrame::OnButtonReset() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.ResetOutputFiles(TRUE);
}

void CMainFrame::OnDocumentation() 
{
	char buf[128];

	sprintf(buf,"%s\\%s", HELP_DIR, "p4pAppDocumentation.htm");
	if( (int)ShellExecute(m_hWnd, NULL, buf, NULL, NULL, SW_SHOWNORMAL) <33)
		AfxMessageBox("Failed to find Help File");	
}

void CMainFrame::OnLocations() 
{
	CP4pAppDoc *pDoc = (CP4pAppDoc *)GetActiveDocument();
	pDoc->m_Pix.ShowLocations();	
}

