/*
* Copyright 2003(c) Theo Pavlidis
* See PixEx.h for a detailed notice on the use of the software
*/	

// Pix.h: interface for the CPix class.
//
//////////////////////////////////////////////////////////////////////

//	DO NOT EDIT THIS FILE OUTSIDE THE p4pApp PROJECT

#if !defined(AFX_PIX_H__853DCC03_A94B_45E2_9F6B_8AC86B579529__INCLUDED_)
#define AFX_PIX_H__853DCC03_A94B_45E2_9F6B_8AC86B579529__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define LVL		256	//	this assumes 8 bits per color

#define INPUT_P	0
#define OUTP1_P	1
#define OUTP2_P	2	// to support extensions
#define TOTAL_P	3

class CPix  // to be used as a junction with pack4png
{
// Operations
public:
	CPix();
	virtual ~CPix();
	int		ReadPix(char *pathname);
	int		WritePix(char *pathname);
	double  InvokeP4P(int strategy, int ColorTableStep, int needMemory);	// third argument is boolean
protected:
	int		Distribution(int Nbins);
	int		Hist1d(int image, int Nbins, double *result);
	int		Hist3d(int image, int N3Dbins, double *result);

// Attributes
protected:
	int	m_width;
	int m_height;
	int m_bpp;		// bytes per pixel
	int m_mono;		// if actually monochrom
	int m_colors;	// number of distinct colors for input image
	int m_limit[2];	// determines whether packing should be aggressive or not
	unsigned char *m_Image[TOTAL_P];
	int m_distribution;
	int m_New;
	int m_Old;		// to support extensions
	int m_zone[3];	// number of zones - at most three color channels - Used for output
};

#endif // !defined(AFX_PIX_H__853DCC03_A94B_45E2_9F6B_8AC86B579529__INCLUDED_)
