/*
 * Functions supporting an application illustrating the use of pack4png
 *
 * COPYRIGHT NOTICE, DISCLAIMER, and LICENSE:

 * Copyright 2003(c) Theo Pavlidis

 * This is 1.1 version (May 2003) of the application and the pack4png DLL library.
 * The USE AT YOUR OWN RISK warning applies emphatically.
 *
 * Permission is hereby granted to use, copy, modify, and distribute this
 * source code, or portions hereof, for any purpose, without fee, subject
 * to the following restrictions:
 *
 * 1. The origin of this source code must not be misrepresented.
 *
 * 2. Altered versions must be plainly marked as such and
 * must not be misrepresented as being the original source.
 *
 * 3. This Copyright notice may not be removed or altered from
 *    any source or altered source distribution.

 * Comments are welcome. Send to t.pavlidis@ieee.org

*/
// PixEx.h: interface for the CPixEx class.
//
//////////////////////////////////////////////////////////////////////

//	DO NOT EDIT THIS FILE OUTSIDE THE p4pApp PROJECT

#ifndef PIXEX_H
#define PIXEX_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Pix.h"
#include "local.h"

class CPixEx : public CPix	// includes facilities to be used with p4pApp
{
// Operations
public:
	CPixEx();
	virtual ~CPixEx();
	int  ReadPix(char *pathname);	// override
	int  WritePix(char *pathname);	// override
	void ResetOutputFiles(BOOL redraw);
	void Push2Old();
	void ShowLocations();
	void FindFileSize();
	void InvokeP4P(int strategy, int ColorTableStep);	// override
	void Quantize(int method);
	int  CreateMemDC(int k);
	int  CreateMemDC(CView *vp, int k);
	void DrawPix(CDC* pDC);
	void Web(CString FileTitle);
	void DefaultTag(char v[]);
	int  HaveOutput() {	return m_Image[m_New] != (unsigned char *)0; }
protected:
	void DrawOnePix(CDC *pDC, int image, int xoff, int yoff, CString *msgp);
	void TrafficSign(CDC *pDC, int x, int y);

// Attributes
public:
	enum { HIST_EQUALIZATION, MOST_SIGN_BITS};

protected:
	int m_levelOld;
	int m_level;	// level of packing 1, 2, 3, 4 + 10*splitzones
	int m_colorStepOld;
	int m_colorStep;	// 0 for pack4png, non-zero (51) for pack4gct
	double m_rmsOld;
	double m_rms;
	CView *m_viewp;
	CDC m_MemDC[TOTAL_P];
	int m_PNGSize[TOTAL_P];
};

#endif // PIXEX_H
