// p4pAppDoc.cpp : implementation of the CP4pAppDoc class
//

#include "stdafx.h"
#include "p4pApp.h"
#include "MainFrm.h"

#include "p4pAppDoc.h"
#include "pngcall.h"
#include "util.h"

#include "pack4png.h"

#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CP4pAppDoc

IMPLEMENT_DYNCREATE(CP4pAppDoc, CDocument)

BEGIN_MESSAGE_MAP(CP4pAppDoc, CDocument)
	//{{AFX_MSG_MAP(CP4pAppDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CP4pAppDoc construction/destruction

CP4pAppDoc::CP4pAppDoc()
{
	m_lastInputDir = IMG_DIR;
}

CP4pAppDoc::~CP4pAppDoc()
{
}

BOOL CP4pAppDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CP4pAppDoc serialization

void CP4pAppDoc::Serialize(CArchive& ar)
{
	CString msg;
	CFile *file = ar.GetFile();
	CString pathName = file->GetFilePath( );
	// check if legitimate name
	CString tail = pathName.Right(3);
	if(tail.CompareNoCase("png") != 0) {
		AfxMessageBox("[File Open/Save/Save As] can handle only .png files");
		return;
	}
	if (ar.IsStoring())
	{
		AfxMessageBox("You must use the S button to save");
	}
	else
	{	// Loading
		BOOL status = m_Pix.ReadPix(pathName.GetBuffer(0));
		((CMainFrame *)AfxGetMainWnd())->HaveImage(status==PNG_READ_OK);
		if(status != PNG_READ_OK) return;
		// The next 3 lines are needed for display
		POSITION pos = GetFirstViewPosition();
		CView* pView = GetNextView(pos);
		m_Pix.CreateMemDC(pView, INPUT_P);
		// save directory name for batch processing
		int lastSlash = pathName.ReverseFind('\\');
		m_lastInputDir = pathName.Left(lastSlash);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CP4pAppDoc diagnostics

#ifdef _DEBUG
void CP4pAppDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CP4pAppDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CP4pAppDoc commands

void CP4pAppDoc::SaveResult()
{
	//	Ask user for file name
	static char szFilter[] = "PNG Files (*.png)|*.png|All Files (*.*)|*.*||";
	CString FileTitle;	// title of document file
	char tag[6];
	m_Pix.DefaultTag(tag);
	FileTitle.Format("%s_%s", tag, GetTitle());
	int lastDot = FileTitle.ReverseFind('.');
	CFileDialog dlg(FALSE, ".png", lastDot>0? FileTitle.Left(lastDot): FileTitle, 
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

	// Two steps are needed below because of string conversion rules
	CString dname = GET_APP->GetProfileString(_T("Parameters"), _T("OutputDir"), ".");
	dlg.m_ofn.lpstrInitialDir = dname;

	if (dlg.DoModal() != IDOK) return;

	m_Pix.WritePix(dlg.GetPathName().GetBuffer(0));		// the real stuff

	// update directory name in registry
	CString tmp = dlg.GetPathName();
	int lastSlash = tmp.ReverseFind('\\');
	if(lastSlash<1) return;
	BOOL saved = GET_APP->WriteProfileString(_T("Parameters"), _T("OutputDir"), tmp.Left(lastSlash));
	ASSERT(saved==TRUE);
}


void CP4pAppDoc::All()
{
	if(_chdir(m_lastInputDir) != 0) {
		AfxMessageBox("Cannot Change Directory to Image Directory");
		return;
	}
	POSITION pos = GetFirstViewPosition();
	CView* pView = GetNextView(pos);
	BOOL status;
	CString msg;
	CString FirstFile = GetTitle();
	// start the search
	CFileFind finder;
	BOOL bWorking = finder.FindFile("*.png");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		if(FirstFile != "Untitled") {
			if(finder.GetFileName() == FirstFile) FirstFile = "Untitled";
			else continue;
		}
		status = m_Pix.ReadPix((finder.GetFileName()).GetBuffer(0));
		if(status != PNG_READ_OK) continue;
		SetTitle( LPCTSTR (finder.GetFileName()) );
		((CMainFrame *)AfxGetMainWnd())->HaveImage(status==PNG_READ_OK);
		m_Pix.CreateMemDC(pView, INPUT_P);
		m_Pix.InvokeP4P(1, 0);	// smallest effort to compress
		pView->Invalidate();
		msg.Format("%s. Next file?", (finder.GetFileName()).GetBuffer(0));
		if(AfxMessageBox(msg.GetBuffer(0), MB_YESNO | MB_ICONQUESTION ) == IDNO) break;
	}
	AfxMessageBox("Done!");
}